// FramesCapturer.cs
//
//  Copyright (C) 2008 [name of author]
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
//
//

using System;
using LongoMatch.Video.Utils;
using LongoMatch.Video;
using Gdk;
using Gtk;
using System.Threading;
using LongoMatch.Video.Handlers;

namespace LongoMatch.Video.Utils
{
	
	
	public class FramesSeriesCapturer
	{
		long start;
		long stop;
		uint interval;
		int totalFrames;
		string seriesName;
		string outputDir;
		string videoFile;
		
		Thread thread;
		
		public event ProgressHandler Progress;
		
		public FramesSeriesCapturer(string videoFile,long start, long stop, uint interval, string outputDir)
		{
			this.videoFile = videoFile;
			this.start= start;
			this.stop = stop;
			this.interval = interval;
			this.outputDir = outputDir;
			this.seriesName = System.IO.Path.GetFileName(outputDir);			
			this.totalFrames = (int)((stop - start ) / interval);
			
		}
		
		public void Start(){
			thread = new Thread(CaptureFrames);
			thread.Start();
		}
		
		public void Cancel(){
			if (thread != null && thread.IsAlive){
				thread.Abort();
				thread.Join();
				System.IO.Directory.Delete(outputDir,true);
				if (Progress != null)
					Application.Invoke(delegate {
						Progress(-1);
					});
			}		
		}
		
		private void CaptureFrames(){
			
			PlayerMaker pm; 
			IFramesCapturer fCapturer;
			long pos;
			Pixbuf frame;
			int i = 0;
			
			Application.Invoke(delegate {
						Progress(0);
					});
			
			System.IO.Directory.CreateDirectory(outputDir);
			
			pm = new PlayerMaker();
			fCapturer = pm.getFramesCapturer();
			fCapturer.Open(videoFile);
			fCapturer.Pause();
			pos = start;			
		
			//TODO add lock to protect start and stop
			while (pos < stop){			
				Console.WriteLine(i);
				if (Progress != null)
					Application.Invoke(delegate {
						Progress((float)i/(float)totalFrames);
					});
				fCapturer.SeekTo(pos,true);				
				frame = fCapturer.CurrentFrame;				
				if (frame != null) {
					frame.Save(System.IO.Path.Combine(outputDir,seriesName+"_" + i +".png"),"png");
				}
				pos += interval;
				i++;
				
			}
			
			
		}
	}
}
